let should_fadeout_grid = true;

window.onload = function() {
    make_services_pretty();
    window.onresize = make_services_pretty;
};

let services_array_to_fade = [];

function make_services_pretty() {
    let services = document.getElementsByClassName("service");

    for (var i = 0; i < services.length; i+=1) {
        let service = services[i].children[0]

        if (service.parentNode.parentNode.classList.contains("service_dropdown_button")) {
            service.parentNode.parentNode.style.display = "block";
        } 
        else {
            service.parentNode.style.display = "block";
        }
    }

    let previous_y = services[0].getBoundingClientRect().y;

    let services_array = [];
    let services_inner_array = [];
    for (var i = 0; i < services.length; i+=1) {
        let current_y = services[i].getBoundingClientRect().y;

        if (previous_y < current_y) {
            services_array.push(services_inner_array);
            services_inner_array = [];
            services_inner_array.push(services[i].children[0]);
        }
        else {
            services_inner_array.push(services[i].children[0]);
        }
        previous_y = current_y;
    }
    services_array.push(services_inner_array);

    let heights = [];
    for (var row_n = 0; row_n < services_array.length; row_n +=1) {
        let height = services_array[row_n][0].getBoundingClientRect().height;
        for (var service_n = 1; service_n < services_array[row_n].length; service_n +=1) {
            let new_height = services_array[row_n][service_n].getBoundingClientRect().height; 
            if (height < new_height) { height = new_height; }
        }

        heights.push(height);
    }

    for (var i = 0; i < heights.length; i+=1) {
        for (let service_n in services_array[i]) {
            let service_image = services_array[i][service_n];
            let height_difference = (heights[i] - service_image.getBoundingClientRect().height) /2 ;
            
            service_image.style.marginTop = height_difference+"px";
            service_image.style.marginBottom = height_difference+"px";
        }
    }

    if (should_fadeout_grid){
        services_array_to_fade = services_array;
        fadeout_services_grid();
    }
};


const MOBILE_COUNT  = [500,  1];
const TABLET_COUNT  = [1050, 2];
const DESKTOP_COUNT = [null, 2];
function fadeout_services_grid() {
    let width = window.innerWidth;

    let count; 
    if (width < MOBILE_COUNT[0]) {
        count = MOBILE_COUNT[1];
    }
    else if (width < TABLET_COUNT[0]) {
        count = TABLET_COUNT[1];
    }
    else {
        count = DESKTOP_COUNT[1];
    }

    let services_hidden = false
    for (var x = 0; x < services_array_to_fade.length; x +=1) {
        for (var y = 0; y < services_array_to_fade[x].length; y +=1) {
            let service = services_array_to_fade[x][y];

            if (x < count) {
                if (service.parentNode.parentNode.classList.contains("service_dropdown_button")) {
                    service.parentNode.parentNode.style.display = "block";
                } 
                else {
                    service.parentNode.style.display = "block";
                }
            }
            else {
                if (service.parentNode.parentNode.classList.contains("service_dropdown_button")) {
                    service.parentNode.parentNode.style.display = "none";
                } 
                else {
                    service.parentNode.style.display = "none";
                }
    
                services_hidden = true;
            }
        }
    }

    if (services_hidden) {
        document.getElementById("services_grid_show_all").style.display = "block";
    }
    else {
        document.getElementById("services_grid_show_all").style.display = "none";
    }
};

function show_hide_fade() {
    let hide_fade_button = document.getElementById("services_grid_show_all");

    if (should_fadeout_grid) {
        should_fadeout_grid = false;

        hide_fade_button.children[0].textContent = "Hide services:";
        hide_fade_button.children[1].style.transform = "rotate(90deg)";

        make_services_pretty();

    }
    else {
        should_fadeout_grid = true;

        hide_fade_button.children[0].textContent = "Show all services:";
        hide_fade_button.children[1].style.transform = "rotate(-90deg)";

        make_services_pretty();
    }
}